<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
        die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

/* display No errors */
error_reporting(0);

if (isset($config)) {
        include_once(dirname(__FILE__) . "/../lib/snmp.php");
}

if (!isset($called_by_script_server)) {
        include_once(dirname(__FILE__) . "/../include/global.php");
        include_once(dirname(__FILE__) . "/../lib/snmp.php");

        array_shift($_SERVER["argv"]);

        print call_user_func_array("ss_MLX_cpu", $_SERVER["argv"]);
}

function ss_MLX_cpu($hostname, $host_id, $snmp_auth, $cmd, $arg1 = "", $arg2 = "") {
        $snmp = explode(":", $snmp_auth);
        $snmp_version   = $snmp[0];
        $snmp_port      = $snmp[1];
        $snmp_timeout   = $snmp[2];
        $ping_retries   = $snmp[3];
        $max_oids               = $snmp[4];

        $snmp_auth_username     = "";
        $snmp_auth_password     = "";
        $snmp_auth_protocol     = "";
        $snmp_priv_passphrase   = "";
        $snmp_priv_protocol     = "";
        $snmp_context           = "";
        $snmp_community                 = "";

        if ($snmp_version == 3) {
                $snmp_auth_username   = $snmp[6];
                $snmp_auth_password   = $snmp[7];
                $snmp_auth_protocol   = $snmp[8];
                $snmp_priv_passphrase = $snmp[9];
                $snmp_priv_protocol   = $snmp[10];
                $snmp_context         = $snmp[11];
        }else{
                $snmp_community = $snmp[5];
        }

        $oids = array(
                "index"                 => ".1.3.6.1.4.1.1991.1.1.2.8.1.1.1",
                "description"   => ".1.3.6.1.4.1.1991.1.1.2.8.1.1.4",
                "usage"                         => ".1.3.6.1.4.1.1991.1.1.2.11.1.1.5"
                );

        if ($cmd == "index") {
                $return_arr = ss_MLX_cpu_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));

                for ($i=0;($i<sizeof($return_arr));$i++) {
                        print $return_arr[$i] . "\n";
                }

        }elseif ($cmd == "num_indexes") {
                $return_arr = ss_MLX_cpu_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));

                print sizeof($return_arr);

        }elseif ($cmd == "query") {
                $arg = $arg1;

                $arr_index = ss_MLX_cpu_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
                $arr = ss_MLX_cpu_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));

                for ($i=0;($i<sizeof($arr_index));$i++) {
                        print $arr_index[$i] . "!" . $arr[$i] . "\n";
                }
        }elseif ($cmd == "get") {
                $arg = $arg1;
                $index = $arg2;

                if (($arg == "usage")) {
                        $snmp_data = cacti_snmp_get($hostname, $snmp_community,$oids[$arg] . ".$index" . ".1.300", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol,$snmp_priv_passphrase,$snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, SNMP_POLLER);
                        /*if (empty($snmp_data)) {
                                return "U";
                        } else {*/
                                return $snmp_data;
                /*      }*/
                }else{
                        return cacti_snmp_get($hostname, $snmp_community, $oids[$arg] . ".$index", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol,$snmp_priv_passphrase,$snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, SNMP_POLLER);
                }
        }
}

function ss_MLX_cpu_reindex($arr) {
        $return_arr = array();

        for ($i=0;($i<sizeof($arr));$i++) {
                $return_arr[$i] = $arr[$i]["value"];
        }

        return $return_arr;
}

?>
